' -------------------------------------------
'          Sterownik silnika krokowego
'         Copyright Piotr Gorecki 2002
' -------------------------------------------

Dim Praca As Bit , Przyciski As Byte , Licznik As Byte , Predkosc As Byte
Config Portb = &B00001111       'modsze-wyjcia do silnika, starsze-wejscia DIP-switch S1
Config Portd = &B1000000       ' 2 najmodsze bity - wejscie przyciskw,
' 4 nastpne -predkosc z DIP-switch'a S2 ostatni bit - wyjcie=brzczyk piezo
Config Timer0 = Timer , Prescale = 64
Enable Interrupts : Enable Ovf0
Portb = &B11110000       'na pocztek wycza silnik i podciga wejscia S1
Portd = 255       'wcza rezyst podcigajace na wejsciach PD.0, PD.5 i wyacza brzczyk

On Timer0 Podprogramik

Do : Loop : End   'pusta ptla

Podprogramik:
Przyciski = Pind And 3       'uzyskujemy stan przyciskw - dwa najmodsze bajty
Predkosc = Pind And &B0111100       'i stan czterech bitw DIP-switcha S2
Shift Predkosc , Left , 2       'przesuwamy to na najstarsze pozycje
Predkosc = Predkosc Or 15       'a do 4 modszych wpisujemy jedynki
Timer0 = Predkosc 'adujemy t warto do Timera0, zmieniajc czas do najbliszego przepenienia
Select Case Przyciski       'sprawdzamy stanu przyciskw
   Case 0:                           'gdy nacinite oba przyciski wcza brzczyk piezo
      Praca = 0 : Reset Portd.6       'wczony midzy PD.6 a plus zasilania
   Case 1:
      Praca = 1 : Incr Licznik       ' nacinity S3 - w gr
   Case 2:
      Praca = 1 : Decr Licznik       ' nacinity S4 - w d
   Case 3:
      Praca = 0 : Set Portd.6       ' w spoczynku wycz brzczyk
End Select
Licznik = Licznik And 3       'zeruje 6 zbdnych bitw omiobitowego licznika
If Praca = 1 Then
Portb = Lookup(licznik , Tabela)
Else
Portb = 0
End If
Return

Tabela:
Data &B11111001 , &B11111100 , &B11110110 , &B11110011       ' w wersji z 4 tranzystorami
'Data &B11000011 , &B11110000 , &B00111100 , &B00001111 'przy kostce ULN2803 po dwa wyjcia rwnolegle





